Tonyu.klass.define({
  fullName: 'user.BGMPlayer',
  shortName: 'BGMPlayer',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_BGMPlayer_main() {
        "use strict";
        var _this=this;
        var _it_11;
        
        _this.isRemoveDecodedSoundDeta=false;
        Tonyu.globals.$Screen.resize(Tonyu.globals.$uiScreen.width,Tonyu.globals.$uiScreen.height);
        Tonyu.globals.$Boot.setFrameRate(60,5);
        _this.allowObj=new Tonyu.classes.kernel.Actor({x: 12,y: 0,p: Tonyu.globals.$pat_base+0,scaleX: 0.5});
        new Tonyu.classes.user.TestChar({x: 100,y: 448,p: Tonyu.globals.$pat_base+2,zOrder: 100});
        new Tonyu.classes.user.TestChar({x: 350,y: 448,p: Tonyu.globals.$pat_base+4,zOrder: 100});
        _this.sounds=Tonyu.globals.$currentProject.getResource().sounds;
        _this.pad=new Tonyu.classes.kernel.Pad({buttonCnt: 2,jujiPadDiagonalEnable: false,button1Text: "A",button2Text: "B"});
        _this.allowY=0;
        _this.idxScrollY=0;
        _this.textX=32;
        _this.textY=4;
        _this.ALLOW_Y_ADD=20;
        _this.TEXT_SIZE=14;
        _this.LIST_MAX=18;
        _this.playingBGMNameOld=null;
        while (true) {
          if (_this.widthOld!=Tonyu.globals.$uiScreen.width||_this.heightOld!=Tonyu.globals.$uiScreen.height) {
            _this.widthOld=Tonyu.globals.$uiScreen.width;
            _this.heightOld=Tonyu.globals.$uiScreen.height;
            Tonyu.globals.$Screen.resize(Tonyu.globals.$uiScreen.width,Tonyu.globals.$uiScreen.height);
            
          }
          if (_this.getkey(37)||_this.pad.getLeft()) {
            _this.keyL++;
          } else {
            _this.keyL=0;
          }
          if (_this.getkey(39)||_this.pad.getRight()) {
            _this.keyR++;
          } else {
            _this.keyR=0;
          }
          if (_this.getkey(38)||_this.pad.getUp()) {
            _this.keyU++;
          } else {
            _this.keyU=0;
          }
          if (_this.getkey(40)||_this.pad.getDown()) {
            _this.keyD++;
          } else {
            _this.keyD=0;
          }
          if (_this.getkey(90)||_this.getkey(32)||_this.getkey(13)||_this.getkey(16)||_this.pad.getButton(1)) {
            _this.keyZ++;
          } else {
            _this.keyZ=0;
          }
          if (_this.getkey(88)||_this.getkey(8)||_this.pad.getButton(2)) {
            _this.keyX++;
          } else {
            _this.keyX=0;
          }
          if (_this.keyU==1||(_this.keyU>=15&&_this.keyU%2==1)) {
            _this.allowY--;
            
          }
          if (_this.keyD==1||(_this.keyD>=15&&_this.keyD%2==1)) {
            _this.allowY++;
            
          }
          if (_this.allowY<0) {
            _this.allowY=_this.sounds.length-1;
          }
          if (_this.allowY>=_this.sounds.length) {
            _this.allowY=0;
          }
          if (_this.allowY-_this.idxScrollY<0) {
            _this.idxScrollY=_this.allowY;
          }
          if (_this.allowY-_this.idxScrollY>=_this.LIST_MAX) {
            _this.idxScrollY=_this.allowY-_this.LIST_MAX+1;
          }
          _this.allowObj.x=_this.textX-12;
          _this.allowObj.y=(_this.allowY-_this.idxScrollY)*_this.ALLOW_Y_ADD+_this.ALLOW_Y_ADD/2;
          if (_this.playingBGMName!=_this.playingBGMNameOld) {
            _this.playingBGMNameOld=_this.playingBGMName;
            _this.playingBGMIdx=0;
            _it_11=Tonyu.iterator(_this.sounds,1);
            while(_it_11.next()) {
              _this.sound=_it_11[0];
              
              if (_this.playingBGMName==_this.sound.name) {
                break;
                
              }
              _this.playingBGMIdx++;
              
            }
            
          }
          if (_this.keyL==1) {
            Tonyu.globals.$sound.pauseBGM();
            
          }
          if (_this.keyR==1) {
            Tonyu.globals.$sound.resumeBGM();
            
          }
          if (_this.keyZ==1) {
            if (_this.isRemoveDecodedSoundDeta) {
              Tonyu.globals.$sound.removeDecodedSoundData(_this.playingBGMNameOld);
            }
            Tonyu.globals.$sound.playBGM(_this.sounds[_this.allowY].name,false);
            
          }
          if (_this.keyX==1) {
            _this.bgmPlayerMode();
            
          }
          _this.playingBGMName=Tonyu.globals.$sound.getPlayingBGMName();
          _this.bgmCurrentTime=Tonyu.globals.$sound.getBGMCurrentTime();
          _this.bgmLength=Tonyu.globals.$sound.getBGMLength();
          if (_this.playingBGMName) {
            if (_this.bgmLength&&_this.bgmCurrentTime>=_this.bgmLength) {
              if (_this.playingBGMIdx<_this.sounds.length-1) {
                Tonyu.globals.$sound.removeDecodedSoundData(_this.playingBGMNameOld);
                if (_this.playingBGMIdx==_this.allowY) {
                  _this.allowY++;
                }
                _this.playingBGMIdx++;
                Tonyu.globals.$sound.playBGM(_this.sounds[_this.playingBGMIdx].name,false);
                
              }
              
            }
            
          }
          _this.i = 0;
          for (; _this.i<_this.LIST_MAX ; _this.i++) {
            {
              
              _this.idx = _this.i+_this.idxScrollY;
              
              
              if (_this.idx>=0&&_this.idx<_this.sounds.length) {
                _this.name=_this.sounds[_this.idx].name;
                if (_this.name==_this.playingBGMName) {
                  _this.col="#0F0";
                } else {
                  _this.col=Tonyu.globals.$clWhite;
                }
                _this.drawText(_this.textX,_this.textY+_this.i*_this.ALLOW_Y_ADD,_this.name,_this.col,_this.TEXT_SIZE);
                
              }
            }
          }
          _this.textTime=_this.formatTime(_this.bgmCurrentTime?_this.bgmCurrentTime:0)+" / "+_this.formatTime(_this.bgmLength?_this.bgmLength:0);
          _this.drawText(200,_this.textY+18*_this.ALLOW_Y_ADD,_this.textTime,Tonyu.globals.$clWhite,30);
          if (_this.playingBGMName) {
            _this.textBGMNo = "("+(_this.playingBGMIdx+1)+"/"+_this.sounds.length+")";
            
            _this.drawText(200,_this.textY+14*_this.ALLOW_Y_ADD,_this.playingBGMName,Tonyu.globals.$clWhite,24);
            _this.drawText(200,_this.textY+16*_this.ALLOW_Y_ADD,_this.textBGMNo,Tonyu.globals.$clWhite,15);
            
          }
          _this.drawText(_this.textX+24,_this.textY+_this.LIST_MAX*_this.ALLOW_Y_ADD,"("+(_this.allowY+1)+"/"+_this.sounds.length+")",Tonyu.globals.$clWhite,15);
          if (T2MediaLib.context) {
            _this.drawText(0,Tonyu.globals.$screenHeight-20,"currentTime:"+T2MediaLib.context.currentTime,"#FFF",12);
            
          }
          _this.update();
          
        }
      },
      fiber$main :function _trc_BGMPlayer_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var _it_11;
        
        _this.isRemoveDecodedSoundDeta=false;
        Tonyu.globals.$Screen.resize(Tonyu.globals.$uiScreen.width,Tonyu.globals.$uiScreen.height);
        Tonyu.globals.$Boot.setFrameRate(60,5);
        _this.allowObj=new Tonyu.classes.kernel.Actor({x: 12,y: 0,p: Tonyu.globals.$pat_base+0,scaleX: 0.5});
        new Tonyu.classes.user.TestChar({x: 100,y: 448,p: Tonyu.globals.$pat_base+2,zOrder: 100});
        new Tonyu.classes.user.TestChar({x: 350,y: 448,p: Tonyu.globals.$pat_base+4,zOrder: 100});
        _this.sounds=Tonyu.globals.$currentProject.getResource().sounds;
        _this.pad=new Tonyu.classes.kernel.Pad({buttonCnt: 2,jujiPadDiagonalEnable: false,button1Text: "A",button2Text: "B"});
        _this.allowY=0;
        _this.idxScrollY=0;
        _this.textX=32;
        _this.textY=4;
        _this.ALLOW_Y_ADD=20;
        _this.TEXT_SIZE=14;
        _this.LIST_MAX=18;
        _this.playingBGMNameOld=null;
        
        _thread.enter(function _trc_BGMPlayer_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (_this.widthOld!=Tonyu.globals.$uiScreen.width||_this.heightOld!=Tonyu.globals.$uiScreen.height) {
                _this.widthOld=Tonyu.globals.$uiScreen.width;
                _this.heightOld=Tonyu.globals.$uiScreen.height;
                Tonyu.globals.$Screen.resize(Tonyu.globals.$uiScreen.width,Tonyu.globals.$uiScreen.height);
                
              }
              if (_this.getkey(37)||_this.pad.getLeft()) {
                _this.keyL++;
              } else {
                _this.keyL=0;
              }
              if (_this.getkey(39)||_this.pad.getRight()) {
                _this.keyR++;
              } else {
                _this.keyR=0;
              }
              if (_this.getkey(38)||_this.pad.getUp()) {
                _this.keyU++;
              } else {
                _this.keyU=0;
              }
              if (_this.getkey(40)||_this.pad.getDown()) {
                _this.keyD++;
              } else {
                _this.keyD=0;
              }
              if (_this.getkey(90)||_this.getkey(32)||_this.getkey(13)||_this.getkey(16)||_this.pad.getButton(1)) {
                _this.keyZ++;
              } else {
                _this.keyZ=0;
              }
              if (_this.getkey(88)||_this.getkey(8)||_this.pad.getButton(2)) {
                _this.keyX++;
              } else {
                _this.keyX=0;
              }
              if (_this.keyU==1||(_this.keyU>=15&&_this.keyU%2==1)) {
                _this.allowY--;
                
              }
              if (_this.keyD==1||(_this.keyD>=15&&_this.keyD%2==1)) {
                _this.allowY++;
                
              }
              if (_this.allowY<0) {
                _this.allowY=_this.sounds.length-1;
              }
              if (_this.allowY>=_this.sounds.length) {
                _this.allowY=0;
              }
              if (_this.allowY-_this.idxScrollY<0) {
                _this.idxScrollY=_this.allowY;
              }
              if (_this.allowY-_this.idxScrollY>=_this.LIST_MAX) {
                _this.idxScrollY=_this.allowY-_this.LIST_MAX+1;
              }
              _this.allowObj.x=_this.textX-12;
              _this.allowObj.y=(_this.allowY-_this.idxScrollY)*_this.ALLOW_Y_ADD+_this.ALLOW_Y_ADD/2;
              if (!(_this.playingBGMName!=_this.playingBGMNameOld)) { __pc=2     ; break; }
              _this.playingBGMNameOld=_this.playingBGMName;
              _this.playingBGMIdx=0;
              _it_11=Tonyu.iterator(_this.sounds,1);
              while(_it_11.next()) {
                _this.sound=_it_11[0];
                
                if (_this.playingBGMName==_this.sound.name) {
                  break;
                  
                }
                _this.playingBGMIdx++;
                
              }
            case 2     :
              
              if (_this.keyL==1) {
                Tonyu.globals.$sound.pauseBGM();
                
              }
              if (_this.keyR==1) {
                Tonyu.globals.$sound.resumeBGM();
                
              }
              if (_this.keyZ==1) {
                if (_this.isRemoveDecodedSoundDeta) {
                  Tonyu.globals.$sound.removeDecodedSoundData(_this.playingBGMNameOld);
                }
                Tonyu.globals.$sound.playBGM(_this.sounds[_this.allowY].name,false);
                
              }
              if (!(_this.keyX==1)) { __pc=4     ; break; }
              _this.fiber$bgmPlayerMode(_thread);
              __pc=3;return;
            case 3:
              
            case 4     :
              
              _this.playingBGMName=Tonyu.globals.$sound.getPlayingBGMName();
              _this.bgmCurrentTime=Tonyu.globals.$sound.getBGMCurrentTime();
              _this.bgmLength=Tonyu.globals.$sound.getBGMLength();
              if (_this.playingBGMName) {
                if (_this.bgmLength&&_this.bgmCurrentTime>=_this.bgmLength) {
                  if (_this.playingBGMIdx<_this.sounds.length-1) {
                    Tonyu.globals.$sound.removeDecodedSoundData(_this.playingBGMNameOld);
                    if (_this.playingBGMIdx==_this.allowY) {
                      _this.allowY++;
                    }
                    _this.playingBGMIdx++;
                    Tonyu.globals.$sound.playBGM(_this.sounds[_this.playingBGMIdx].name,false);
                    
                  }
                  
                }
                
              }
              _this.i = 0;
              for (; _this.i<_this.LIST_MAX ; _this.i++) {
                {
                  
                  _this.idx = _this.i+_this.idxScrollY;
                  
                  
                  if (_this.idx>=0&&_this.idx<_this.sounds.length) {
                    _this.name=_this.sounds[_this.idx].name;
                    if (_this.name==_this.playingBGMName) {
                      _this.col="#0F0";
                    } else {
                      _this.col=Tonyu.globals.$clWhite;
                    }
                    _this.drawText(_this.textX,_this.textY+_this.i*_this.ALLOW_Y_ADD,_this.name,_this.col,_this.TEXT_SIZE);
                    
                  }
                }
              }
              _this.textTime=_this.formatTime(_this.bgmCurrentTime?_this.bgmCurrentTime:0)+" / "+_this.formatTime(_this.bgmLength?_this.bgmLength:0);
              _this.drawText(200,_this.textY+18*_this.ALLOW_Y_ADD,_this.textTime,Tonyu.globals.$clWhite,30);
              if (_this.playingBGMName) {
                _this.textBGMNo = "("+(_this.playingBGMIdx+1)+"/"+_this.sounds.length+")";
                
                _this.drawText(200,_this.textY+14*_this.ALLOW_Y_ADD,_this.playingBGMName,Tonyu.globals.$clWhite,24);
                _this.drawText(200,_this.textY+16*_this.ALLOW_Y_ADD,_this.textBGMNo,Tonyu.globals.$clWhite,15);
                
              }
              _this.drawText(_this.textX+24,_this.textY+_this.LIST_MAX*_this.ALLOW_Y_ADD,"("+(_this.allowY+1)+"/"+_this.sounds.length+")",Tonyu.globals.$clWhite,15);
              if (T2MediaLib.context) {
                _this.drawText(0,Tonyu.globals.$screenHeight-20,"currentTime:"+T2MediaLib.context.currentTime,"#FFF",12);
                
              }
              _this.fiber$update(_thread);
              __pc=5;return;
            case 5:
              
              __pc=1;break;
            case 6     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      formatTime :function _trc_BGMPlayer_formatTime(second) {
        "use strict";
        var _this=this;
        
        return ""+_this.floor(second/3600)+":"+_this.floor(second/60/10%6)+_this.floor(second/60%10)+":"+_this.floor(second/10%6)+_this.floor(second%10);
      },
      fiber$formatTime :function _trc_BGMPlayer_f_formatTime(_thread,second) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=""+_this.floor(second/3600)+":"+_this.floor(second/60/10%6)+_this.floor(second/60%10)+":"+_this.floor(second/10%6)+_this.floor(second%10);return;
        
        
        _thread.retVal=_this;return;
      },
      bgmPlayerMode :function _trc_BGMPlayer_bgmPlayerMode() {
        "use strict";
        var _this=this;
        
        _this.loadPage(Tonyu.classes.user.Main);
      },
      fiber$bgmPlayerMode :function _trc_BGMPlayer_f_bgmPlayerMode(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_BGMPlayer_ent_bgmPlayerMode(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$loadPage(_thread, Tonyu.classes.user.Main);
              __pc=1;return;
            case 1:
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"formatTime":{"nowait":false},"bgmPlayerMode":{"nowait":false}},"fields":{"i":{},"name":{},"idx":{},"col":{},"textBGMNo":{},"isRemoveDecodedSoundDeta":{},"allowObj":{},"sounds":{},"pad":{},"allowY":{},"idxScrollY":{},"textX":{},"textY":{},"ALLOW_Y_ADD":{},"TEXT_SIZE":{},"LIST_MAX":{},"playingBGMNameOld":{},"widthOld":{},"heightOld":{},"keyL":{},"keyR":{},"keyU":{},"keyD":{},"keyZ":{},"keyX":{},"playingBGMName":{},"playingBGMIdx":{},"sound":{},"bgmCurrentTime":{},"bgmLength":{},"textTime":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Main_main() {
        "use strict";
        var _this=this;
        
        _this.isRemoveDecodedSoundDeta=false;
        Tonyu.globals.$Screen.resize(500,500);
        Tonyu.globals.$Boot.setFrameRate(60,5);
        new Tonyu.classes.user.TestChar({x: 0,y: 500-16,p: Tonyu.globals.$pat_base+2,zOrder: 100});
        new Tonyu.classes.user.TestChar({x: (Tonyu.globals.$screenWidth+32)/2,y: 500-16,p: Tonyu.globals.$pat_base+4,zOrder: 100});
        _this.sounds=Tonyu.globals.$currentProject.getResource().sounds;
        if (_this.sounds==null||_this.sounds.length==0) {
          _this.die();
          _this.update();
          
        }
        _this.x=100;
        _this.y=100;
        _this.scaleX=0.5;
        _this.p=Tonyu.globals.$pat_base+0;
        _this.allowY=0;
        _this.pad=new Tonyu.classes.kernel.Pad({buttonCnt: 2,jujiPadDiagonalEnable: false,button1Text: "A",button2Text: "B"});
        _this.bgmOld=null;
        _this.bgmId=- 1;
        _this.selectBgmIdx=0;
        _this.loop=true;
        _this.startTime=0;
        _this.loopStartTime=0;
        _this.loopEndTime=0;
        _this.volume=128;
        _this.tempo=1;
        _this.pan=0;
        _this.masterVolume=128;
        _this.bgmMasterVolume=128;
        _this.seMasterVolume=128;
        _this.bgmsPlayNum=2;
        _this.isTextShow=true;
        _this.isBgmPlayerMode=false;
        _this.tempX=300;
        _this.tempY=0;
        _this.TEMP_Y_ADD=18;
        _this.TEMP_TEXT_SIZE=14;
        _this.textMenuBgmId=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← bgmID →"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuSelectBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← bgm select →"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuLoop=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← loop →"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuStartTime=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← startTime →"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuLoopStartTime=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← loopStartTime →"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuLoopEndTime=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← loopEndTime →"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuPlayBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "bgm play"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuStopBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "bgm stop"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuPauseBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "bgm pause"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuResumeBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "bgm resume"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuBgmVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set bgm volume →"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuBgmTempo=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set bgm tempo →"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuBgmPan=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set bgm pan →"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuBgmLoop=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set bgm loop →"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuBgmLoopStartTime=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set bgm loopStartTime →"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuBgmLoopEndTime=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set bgm loopEndTime →"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set masterVolume →"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuBgmMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set bgmMastervolume →"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuSeMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set seMastervolume →"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuPlayBgms=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuAllStopBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "all stop bgm"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuAllResetBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "all reset bgm"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuPlaySe=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "se play"});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuTextHide=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMenuPlayerMode=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: ""});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.tempX=0;
        _this.tempY=0;
        _this.TEMP_Y_ADD=18;
        _this.TEMP_TEXT_SIZE=14;
        _this.textBgmId=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textSelectBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textLoopBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textStartTimeBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textLoopStartTimeBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textLoopEndTimeBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textVolumeBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textTempoBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textPanBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textBgmMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textSeMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textPlayingBgmName=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textGetBgmCurrentTime=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textGetBgmLength=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textGetBgmVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textGetBgmTempo=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textGetBgmPan=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textGetBgmLoop=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textGetBgmLoopStartTime=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textGetBgmLoopEndTime=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textGetMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textGetBgmMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textGetSeMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        _this.textFPS=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
        _this.tempY+=_this.TEMP_Y_ADD;
        while (true) {
          if (_this.getkey(37)||_this.pad.getLeft()) {
            _this.keyL++;
          } else {
            _this.keyL=0;
          }
          if (_this.getkey(39)||_this.pad.getRight()) {
            _this.keyR++;
          } else {
            _this.keyR=0;
          }
          if (_this.getkey(38)||_this.pad.getUp()) {
            _this.keyU++;
          } else {
            _this.keyU=0;
          }
          if (_this.getkey(40)||_this.pad.getDown()) {
            _this.keyD++;
          } else {
            _this.keyD=0;
          }
          if (_this.getkey(90)||_this.getkey(32)||_this.getkey(16)||_this.pad.getButton(1)) {
            _this.keyZ++;
          } else {
            _this.keyZ=0;
          }
          if (_this.getkey(88)||_this.getkey(8)||_this.pad.getButton(2)) {
            _this.keyX++;
          } else {
            _this.keyX=0;
          }
          if (_this.keyU==1||(_this.keyU>=15&&_this.keyU%5==1)) {
            _this.allowY--;
            
          }
          if (_this.keyD==1||(_this.keyD>=15&&_this.keyD%5==1)) {
            _this.allowY++;
            
          }
          if (_this.allowY<0) {
            _this.allowY=23;
          } else {
            if (_this.allowY>23) {
              _this.allowY=0;
            }
          }
          _this.x=300-16;
          _this.y=_this.allowY*18+8;
          if (_this.allowY==0) {
            if (_this.keyL==1||_this.keyL>=15) {
              _this.bgmId--;
              if (_this.bgmId<- 1) {
                _this.bgmId=- 1;
              }
              
            }
            if (_this.keyR==1||_this.keyR>=15) {
              _this.bgmId++;
              if (_this.bgmId>=Tonyu.globals.$sound.getBGMPlayerMax()) {
                _this.bgmId=Tonyu.globals.$sound.getBGMPlayerMax()-1;
              }
              
            }
            if (_this.keyZ==1||_this.keyZ>=15) {
              _this.playBgm();
              
            }
            
          } else {
            if (_this.allowY==1) {
              if (_this.keyL==1||_this.keyL>=15) {
                _this.selectBgmIdx--;
                if (_this.selectBgmIdx<0) {
                  _this.selectBgmIdx=_this.sounds.length-1;
                }
                
              }
              if (_this.keyR==1||_this.keyR>=15) {
                _this.selectBgmIdx++;
                if (_this.selectBgmIdx>=_this.sounds.length) {
                  _this.selectBgmIdx=0;
                }
                
              }
              if (_this.keyZ==1||_this.keyZ>=15) {
                _this.playBgm();
                
              }
              
            } else {
              if (_this.allowY==2) {
                if (_this.keyL==1||_this.keyL>=15) {
                  _this.loop=! _this.loop;
                  
                }
                if (_this.keyR==1||_this.keyR>=15) {
                  _this.loop=! _this.loop;
                  
                }
                if (_this.keyZ==1||_this.keyZ>=15) {
                  _this.playBgm();
                  
                }
                
              } else {
                if (_this.allowY==3) {
                  if (_this.keyL==1||_this.keyL>=15) {
                    _this.startTime-=0.1;
                    if (_this.startTime<0) {
                      _this.startTime=0;
                    }
                    
                  }
                  if (_this.keyR==1||_this.keyR>=15) {
                    _this.startTime+=0.1;
                    
                  }
                  if (_this.keyZ==1||_this.keyZ>=15) {
                    _this.playBgm();
                    
                  }
                  
                } else {
                  if (_this.allowY==4) {
                    if (_this.keyL==1||_this.keyL>=15) {
                      _this.loopStartTime-=0.1;
                      if (_this.loopStartTime<0) {
                        _this.loopStartTime=0;
                      }
                      
                    }
                    if (_this.keyR==1||_this.keyR>=15) {
                      _this.loopStartTime+=0.1;
                      
                    }
                    if (_this.keyZ==1||_this.keyZ>=15) {
                      _this.playBgm();
                      
                    }
                    
                  } else {
                    if (_this.allowY==5) {
                      if (_this.keyL==1||_this.keyL>=15) {
                        _this.loopEndTime-=0.1;
                        if (_this.loopEndTime<0) {
                          _this.loopEndTime=0;
                        }
                        
                      }
                      if (_this.keyR==1||_this.keyR>=15) {
                        _this.loopEndTime+=0.1;
                        
                      }
                      if (_this.keyZ==1||_this.keyZ>=15) {
                        _this.playBgm();
                        
                      }
                      
                    } else {
                      if (_this.allowY==6) {
                        if (_this.keyZ==1||_this.keyZ>=15) {
                          _this.playBgm();
                          
                        }
                        
                      } else {
                        if (_this.allowY==7) {
                          if (_this.keyZ==1||_this.keyZ>=15) {
                            _this.stopBgm();
                            
                          }
                          
                        } else {
                          if (_this.allowY==8) {
                            if (_this.keyZ==1||_this.keyZ>=15) {
                              _this.pauseBgm();
                              
                            }
                            
                          } else {
                            if (_this.allowY==9) {
                              if (_this.keyZ==1||_this.keyZ>=15) {
                                _this.resumeBgm();
                                
                              }
                              
                            } else {
                              if (_this.allowY==10) {
                                if (_this.keyL==1||_this.keyL>=15) {
                                  _this.volume-=1;
                                  if (_this.volume<0) {
                                    _this.volume=0;
                                  }
                                  
                                }
                                if (_this.keyR==1||_this.keyR>=15) {
                                  _this.volume+=1;
                                  
                                }
                                if (_this.keyZ==1||_this.keyZ>=15) {
                                  _this.setBgmVolume();
                                  
                                }
                                
                              } else {
                                if (_this.allowY==11) {
                                  if (_this.keyL==1||_this.keyL>=15) {
                                    _this.tempo-=0.015625;
                                    if (_this.tempo<0) {
                                      _this.tempo=0;
                                    }
                                    
                                  }
                                  if (_this.keyR==1||_this.keyR>=15) {
                                    _this.tempo+=0.015625;
                                    
                                  }
                                  if (_this.keyZ==1||_this.keyZ>=15) {
                                    _this.setBgmTempo();
                                    
                                  }
                                  
                                } else {
                                  if (_this.allowY==12) {
                                    if (_this.keyL==1||_this.keyL>=15) {
                                      _this.pan-=1/16;
                                      if (_this.pan<- 1) {
                                        _this.pan=- 1;
                                      }
                                      
                                    }
                                    if (_this.keyR==1||_this.keyR>=15) {
                                      _this.pan+=1/16;
                                      if (_this.pan>1) {
                                        _this.pan=1;
                                      }
                                      
                                    }
                                    if (_this.keyZ==1||_this.keyZ>=15) {
                                      _this.setBgmPan();
                                      
                                    }
                                    
                                  } else {
                                    if (_this.allowY==13) {
                                      if (_this.keyL==1||_this.keyL>=15) {
                                        _this.loop=! _this.loop;
                                        
                                      }
                                      if (_this.keyR==1||_this.keyR>=15) {
                                        _this.loop=! _this.loop;
                                        
                                      }
                                      if (_this.keyZ==1||_this.keyZ>=15) {
                                        _this.setBgmLoop();
                                        
                                      }
                                      
                                    } else {
                                      if (_this.allowY==14) {
                                        if (_this.keyL==1||_this.keyL>=15) {
                                          _this.loopStartTime-=0.1;
                                          if (_this.loopStartTime<0) {
                                            _this.loopStartTime=0;
                                          }
                                          
                                        }
                                        if (_this.keyR==1||_this.keyR>=15) {
                                          _this.loopStartTime+=0.1;
                                          
                                        }
                                        if (_this.keyZ==1||_this.keyZ>=15) {
                                          _this.setBgmLoopStartTime();
                                          
                                        }
                                        
                                      } else {
                                        if (_this.allowY==15) {
                                          if (_this.keyL==1||_this.keyL>=15) {
                                            _this.loopEndTime-=0.1;
                                            if (_this.loopEndTime<0) {
                                              _this.loopEndTime=0;
                                            }
                                            
                                          }
                                          if (_this.keyR==1||_this.keyR>=15) {
                                            _this.loopEndTime+=0.1;
                                            
                                          }
                                          if (_this.keyZ==1||_this.keyZ>=15) {
                                            _this.setBgmLoopEndTime();
                                            
                                          }
                                          
                                        } else {
                                          if (_this.allowY==16) {
                                            if (_this.keyL==1||_this.keyL>=15) {
                                              _this.masterVolume-=1;
                                              if (_this.masterVolume<0) {
                                                _this.masterVolume=0;
                                              }
                                              
                                            }
                                            if (_this.keyR==1||_this.keyR>=15) {
                                              _this.masterVolume+=1;
                                              
                                            }
                                            if (_this.keyZ==1||_this.keyZ>=15) {
                                              _this.setMasterVolume();
                                              
                                            }
                                            
                                          } else {
                                            if (_this.allowY==17) {
                                              if (_this.keyL==1||_this.keyL>=15) {
                                                _this.bgmMasterVolume-=1;
                                                if (_this.bgmMasterVolume<0) {
                                                  _this.bgmMasterVolume=0;
                                                }
                                                
                                              }
                                              if (_this.keyR==1||_this.keyR>=15) {
                                                _this.bgmMasterVolume+=1;
                                                
                                              }
                                              if (_this.keyZ==1||_this.keyZ>=15) {
                                                _this.setBgmMasterVolume();
                                                
                                              }
                                              
                                            } else {
                                              if (_this.allowY==18) {
                                                if (_this.keyL==1||_this.keyL>=15) {
                                                  _this.seMasterVolume-=1;
                                                  if (_this.seMasterVolume<0) {
                                                    _this.seMasterVolume=0;
                                                  }
                                                  
                                                }
                                                if (_this.keyR==1||_this.keyR>=15) {
                                                  _this.seMasterVolume+=1;
                                                  
                                                }
                                                if (_this.keyZ==1||_this.keyZ>=15) {
                                                  _this.setSeMasterVolume();
                                                  
                                                }
                                                
                                              } else {
                                                if (_this.allowY==19) {
                                                  if (_this.keyL==1||_this.keyL>=15) {
                                                    _this.bgmsPlayNum-=1;
                                                    if (_this.bgmsPlayNum<2) {
                                                      _this.bgmsPlayNum=2;
                                                    }
                                                    
                                                  }
                                                  if (_this.keyR==1||_this.keyR>=15) {
                                                    _this.bgmsPlayNum+=1;
                                                    _this.size = Tonyu.globals.$sound.getBGMPlayerMax();
                                                    
                                                    if (_this.bgmsPlayNum>_this.size) {
                                                      _this.bgmsPlayNum=_this.size;
                                                    }
                                                    
                                                  }
                                                  if (_this.keyZ==1||_this.keyZ>=15) {
                                                    _this.playBgms();
                                                    
                                                  }
                                                  
                                                } else {
                                                  if (_this.allowY==20) {
                                                    if (_this.keyZ==1||_this.keyZ>=15) {
                                                      _this.allStopBgm();
                                                      
                                                    }
                                                    
                                                  } else {
                                                    if (_this.allowY==21) {
                                                      if (_this.keyZ==1||_this.keyZ>=15) {
                                                        _this.allResetBgm();
                                                        
                                                      }
                                                      
                                                    } else {
                                                      if (_this.allowY==22) {
                                                        if (_this.keyZ==1||_this.keyZ>=15) {
                                                          _this.playSe();
                                                          
                                                        }
                                                        
                                                      } else {
                                                        if (_this.allowY==23) {
                                                          if (_this.keyZ==1||_this.keyZ>=15) {
                                                            _this.textHide();
                                                            
                                                          }
                                                          
                                                        }
                                                      }
                                                    }
                                                  }
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
          if (_this.keyX==1) {
            _this.bgmPlayerMode();
            
          }
          if (_this.isTextShow) {
            _this.textBgmId.text="bgmID : "+(_this.bgmId==- 1?"default(0)":_this.bgmId);
            _this.textSelectBgm.text="selectBGM : ("+(_this.selectBgmIdx+1)+"/"+_this.sounds.length+") "+_this.sounds[_this.selectBgmIdx].name;
            _this.textLoopBgm.text="loop : "+_this.loop;
            _this.textStartTimeBgm.text="startTime : "+_this.startTime;
            _this.textLoopStartTimeBgm.text="loopStartTime : "+_this.loopStartTime;
            _this.textLoopEndTimeBgm.text="loopEndTime : "+_this.loopEndTime;
            _this.textVolumeBgm.text="volume : "+_this.volume;
            _this.textTempoBgm.text="tempo : "+_this.tempo;
            _this.textPanBgm.text="pan : "+_this.pan;
            _this.textMasterVolume.text="masterVolume : "+_this.masterVolume;
            _this.textBgmMasterVolume.text="bgmMasterVolume : "+_this.bgmMasterVolume;
            _this.textSeMasterVolume.text="seMasterVolume : "+_this.seMasterVolume;
            if (_this.bgmId==- 1) {
              _this.textPlayingBgmName.text="bgmPlayingBGM : "+Tonyu.globals.$sound.getPlayingBGMName();
              _this.textGetBgmCurrentTime.text="bgmCurrentTime : "+Tonyu.globals.$sound.getBGMCurrentTime();
              _this.textGetBgmLength.text="bgmLength : "+Tonyu.globals.$sound.getBGMLength();
              _this.textGetBgmVolume.text="bgmVolume : "+Tonyu.globals.$sound.getBGMVolume();
              _this.textGetBgmTempo.text="bgmTempo : "+Tonyu.globals.$sound.getBGMTempo();
              _this.textGetBgmPan.text="bgmPan : "+Tonyu.globals.$sound.getBGMPan();
              _this.textGetBgmLoop.text="bgmLoop : "+Tonyu.globals.$sound.isBGMLoop();
              _this.textGetBgmLoopStartTime.text="bgmLoopStartTime : "+Tonyu.globals.$sound.getBGMLoopStartTime();
              _this.textGetBgmLoopEndTime.text="bgmLoopEndTime : "+Tonyu.globals.$sound.getBGMLoopEndTime();
              
            } else {
              _this.textPlayingBgmName.text="bgmPlayingBGM : "+Tonyu.globals.$sound.getPlayingBGMNameID(_this.bgmId);
              _this.textGetBgmCurrentTime.text="bgmCurrentTime : "+Tonyu.globals.$sound.getBGMCurrentTimeID(_this.bgmId);
              _this.textGetBgmLength.text="bgmLength : "+Tonyu.globals.$sound.getBGMLengthID(_this.bgmId);
              _this.textGetBgmVolume.text="bgmVolume : "+Tonyu.globals.$sound.getBGMVolumeID(_this.bgmId);
              _this.textGetBgmTempo.text="bgmTempo : "+Tonyu.globals.$sound.getBGMTempoID(_this.bgmId);
              _this.textGetBgmPan.text="bgmPan : "+Tonyu.globals.$sound.getBGMPanID(_this.bgmId);
              _this.textGetBgmLoop.text="bgmLoop : "+Tonyu.globals.$sound.isBGMLoopID(_this.bgmId);
              _this.textGetBgmLoopStartTime.text="bgmLoopStartTime : "+Tonyu.globals.$sound.getBGMLoopStartTimeID(_this.bgmId);
              _this.textGetBgmLoopEndTime.text="bgmLoopEndTime : "+Tonyu.globals.$sound.getBGMLoopEndTimeID(_this.bgmId);
              
            }
            _this.textGetMasterVolume.text="masterVolume : "+Tonyu.globals.$sound.getMasterVolume();
            _this.textGetBgmMasterVolume.text="bgmMasterVolume : "+Tonyu.globals.$sound.getBGMMasterVolume();
            _this.textGetSeMasterVolume.text="seMasterVolume : "+Tonyu.globals.$sound.getSEMasterVolume();
            _this.textMenuPlayBgms.text="← bgms play ("+_this.bgmsPlayNum+") →";
            _this.textMenuTextHide.text="text hide";
            
          } else {
            _this.textMenuTextHide.text="text show";
            
          }
          _this.textFPS.text="FPS : "+Tonyu.globals.$Boot.getMeasuredFps();
          if (T2MediaLib.context) {
            _this.drawText(0,Tonyu.globals.$screenHeight-20,"currentTime:"+T2MediaLib.context.currentTime,"#FFF",12);
            
          }
          _this.update();
          _this.textMenuBgmId.fillStyle="#FFF";
          _this.textMenuSelectBgm.fillStyle="#FFF";
          _this.textMenuStartTime.fillStyle="#FFF";
          _this.textMenuLoop.fillStyle="#FFF";
          _this.textMenuLoopStartTime.fillStyle="#FFF";
          _this.textMenuLoopEndTime.fillStyle="#FFF";
          _this.textMenuPlayBgm.fillStyle="#FFF";
          _this.textMenuStopBgm.fillStyle="#FFF";
          _this.textMenuPauseBgm.fillStyle="#FFF";
          _this.textMenuResumeBgm.fillStyle="#FFF";
          _this.textMenuBgmVolume.fillStyle="#FFF";
          _this.textMenuBgmTempo.fillStyle="#FFF";
          _this.textMenuBgmPan.fillStyle="#FFF";
          _this.textMenuBgmLoop.fillStyle="#FFF";
          _this.textMenuBgmLoopStartTime.fillStyle="#FFF";
          _this.textMenuBgmLoopEndTime.fillStyle="#FFF";
          _this.textMenuMasterVolume.fillStyle="#FFF";
          _this.textMenuBgmMasterVolume.fillStyle="#FFF";
          _this.textMenuSeMasterVolume.fillStyle="#FFF";
          _this.textMenuPlayBgms.fillStyle="#FFF";
          _this.textMenuAllStopBgm.fillStyle="#FFF";
          _this.textMenuAllResetBgm.fillStyle="#FFF";
          _this.textMenuPlaySe.fillStyle="#FFF";
          _this.textMenuTextHide.fillStyle="#FFF";
          _this.textMenuPlayerMode.fillStyle="#FFF";
          
        }
      },
      fiber$main :function _trc_Main_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.isRemoveDecodedSoundDeta=false;
        Tonyu.globals.$Screen.resize(500,500);
        Tonyu.globals.$Boot.setFrameRate(60,5);
        new Tonyu.classes.user.TestChar({x: 0,y: 500-16,p: Tonyu.globals.$pat_base+2,zOrder: 100});
        new Tonyu.classes.user.TestChar({x: (Tonyu.globals.$screenWidth+32)/2,y: 500-16,p: Tonyu.globals.$pat_base+4,zOrder: 100});
        _this.sounds=Tonyu.globals.$currentProject.getResource().sounds;
        
        _thread.enter(function _trc_Main_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              if (!(_this.sounds==null||_this.sounds.length==0)) { __pc=2     ; break; }
              _this.die();
              _this.fiber$update(_thread);
              __pc=1;return;
            case 1:
              
            case 2     :
              
              _this.x=100;
              _this.y=100;
              _this.scaleX=0.5;
              _this.p=Tonyu.globals.$pat_base+0;
              _this.allowY=0;
              _this.pad=new Tonyu.classes.kernel.Pad({buttonCnt: 2,jujiPadDiagonalEnable: false,button1Text: "A",button2Text: "B"});
              _this.bgmOld=null;
              _this.bgmId=- 1;
              _this.selectBgmIdx=0;
              _this.loop=true;
              _this.startTime=0;
              _this.loopStartTime=0;
              _this.loopEndTime=0;
              _this.volume=128;
              _this.tempo=1;
              _this.pan=0;
              _this.masterVolume=128;
              _this.bgmMasterVolume=128;
              _this.seMasterVolume=128;
              _this.bgmsPlayNum=2;
              _this.isTextShow=true;
              _this.isBgmPlayerMode=false;
              _this.tempX=300;
              _this.tempY=0;
              _this.TEMP_Y_ADD=18;
              _this.TEMP_TEXT_SIZE=14;
              _this.textMenuBgmId=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← bgmID →"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuSelectBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← bgm select →"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuLoop=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← loop →"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuStartTime=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← startTime →"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuLoopStartTime=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← loopStartTime →"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuLoopEndTime=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← loopEndTime →"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuPlayBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "bgm play"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuStopBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "bgm stop"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuPauseBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "bgm pause"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuResumeBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "bgm resume"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuBgmVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set bgm volume →"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuBgmTempo=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set bgm tempo →"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuBgmPan=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set bgm pan →"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuBgmLoop=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set bgm loop →"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuBgmLoopStartTime=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set bgm loopStartTime →"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuBgmLoopEndTime=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set bgm loopEndTime →"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set masterVolume →"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuBgmMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set bgmMastervolume →"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuSeMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "← set seMastervolume →"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuPlayBgms=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuAllStopBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "all stop bgm"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuAllResetBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "all reset bgm"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuPlaySe=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: "se play"});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuTextHide=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMenuPlayerMode=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE,text: ""});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.tempX=0;
              _this.tempY=0;
              _this.TEMP_Y_ADD=18;
              _this.TEMP_TEXT_SIZE=14;
              _this.textBgmId=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textSelectBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textLoopBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textStartTimeBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textLoopStartTimeBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textLoopEndTimeBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textVolumeBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textTempoBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textPanBgm=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textBgmMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textSeMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FF0",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textPlayingBgmName=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textGetBgmCurrentTime=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textGetBgmLength=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textGetBgmVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textGetBgmTempo=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textGetBgmPan=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textGetBgmLoop=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textGetBgmLoopStartTime=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textGetBgmLoopEndTime=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textGetMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textGetBgmMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textGetSeMasterVolume=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
              _this.textFPS=new Tonyu.classes.kernel.Actor({x: _this.tempX,y: _this.tempY,align: "left",fillStyle: "#FFF",size: _this.TEMP_TEXT_SIZE});
              _this.tempY+=_this.TEMP_Y_ADD;
            case 3:
              if (_this.getkey(37)||_this.pad.getLeft()) {
                _this.keyL++;
              } else {
                _this.keyL=0;
              }
              if (_this.getkey(39)||_this.pad.getRight()) {
                _this.keyR++;
              } else {
                _this.keyR=0;
              }
              if (_this.getkey(38)||_this.pad.getUp()) {
                _this.keyU++;
              } else {
                _this.keyU=0;
              }
              if (_this.getkey(40)||_this.pad.getDown()) {
                _this.keyD++;
              } else {
                _this.keyD=0;
              }
              if (_this.getkey(90)||_this.getkey(32)||_this.getkey(16)||_this.pad.getButton(1)) {
                _this.keyZ++;
              } else {
                _this.keyZ=0;
              }
              if (_this.getkey(88)||_this.getkey(8)||_this.pad.getButton(2)) {
                _this.keyX++;
              } else {
                _this.keyX=0;
              }
              if (_this.keyU==1||(_this.keyU>=15&&_this.keyU%5==1)) {
                _this.allowY--;
                
              }
              if (_this.keyD==1||(_this.keyD>=15&&_this.keyD%5==1)) {
                _this.allowY++;
                
              }
              if (_this.allowY<0) {
                _this.allowY=23;
              } else {
                if (_this.allowY>23) {
                  _this.allowY=0;
                }
              }
              _this.x=300-16;
              _this.y=_this.allowY*18+8;
              if (!(_this.allowY==0)) { __pc=6     ; break; }
              if (_this.keyL==1||_this.keyL>=15) {
                _this.bgmId--;
                if (_this.bgmId<- 1) {
                  _this.bgmId=- 1;
                }
                
              }
              if (_this.keyR==1||_this.keyR>=15) {
                _this.bgmId++;
                if (_this.bgmId>=Tonyu.globals.$sound.getBGMPlayerMax()) {
                  _this.bgmId=Tonyu.globals.$sound.getBGMPlayerMax()-1;
                }
                
              }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=5     ; break; }
              _this.fiber$playBgm(_thread);
              __pc=4;return;
            case 4:
              
            case 5     :
              
              __pc=98    ;break;
            case 6     :
              if (!(_this.allowY==1)) { __pc=9     ; break; }
              if (_this.keyL==1||_this.keyL>=15) {
                _this.selectBgmIdx--;
                if (_this.selectBgmIdx<0) {
                  _this.selectBgmIdx=_this.sounds.length-1;
                }
                
              }
              if (_this.keyR==1||_this.keyR>=15) {
                _this.selectBgmIdx++;
                if (_this.selectBgmIdx>=_this.sounds.length) {
                  _this.selectBgmIdx=0;
                }
                
              }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=8     ; break; }
              _this.fiber$playBgm(_thread);
              __pc=7;return;
            case 7:
              
            case 8     :
              
              __pc=97    ;break;
            case 9     :
              if (!(_this.allowY==2)) { __pc=12    ; break; }
              if (_this.keyL==1||_this.keyL>=15) {
                _this.loop=! _this.loop;
                
              }
              if (_this.keyR==1||_this.keyR>=15) {
                _this.loop=! _this.loop;
                
              }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=11    ; break; }
              _this.fiber$playBgm(_thread);
              __pc=10;return;
            case 10:
              
            case 11    :
              
              __pc=96    ;break;
            case 12    :
              if (!(_this.allowY==3)) { __pc=15    ; break; }
              if (_this.keyL==1||_this.keyL>=15) {
                _this.startTime-=0.1;
                if (_this.startTime<0) {
                  _this.startTime=0;
                }
                
              }
              if (_this.keyR==1||_this.keyR>=15) {
                _this.startTime+=0.1;
                
              }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=14    ; break; }
              _this.fiber$playBgm(_thread);
              __pc=13;return;
            case 13:
              
            case 14    :
              
              __pc=95    ;break;
            case 15    :
              if (!(_this.allowY==4)) { __pc=18    ; break; }
              if (_this.keyL==1||_this.keyL>=15) {
                _this.loopStartTime-=0.1;
                if (_this.loopStartTime<0) {
                  _this.loopStartTime=0;
                }
                
              }
              if (_this.keyR==1||_this.keyR>=15) {
                _this.loopStartTime+=0.1;
                
              }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=17    ; break; }
              _this.fiber$playBgm(_thread);
              __pc=16;return;
            case 16:
              
            case 17    :
              
              __pc=94    ;break;
            case 18    :
              if (!(_this.allowY==5)) { __pc=21    ; break; }
              if (_this.keyL==1||_this.keyL>=15) {
                _this.loopEndTime-=0.1;
                if (_this.loopEndTime<0) {
                  _this.loopEndTime=0;
                }
                
              }
              if (_this.keyR==1||_this.keyR>=15) {
                _this.loopEndTime+=0.1;
                
              }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=20    ; break; }
              _this.fiber$playBgm(_thread);
              __pc=19;return;
            case 19:
              
            case 20    :
              
              __pc=93    ;break;
            case 21    :
              if (!(_this.allowY==6)) { __pc=24    ; break; }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=23    ; break; }
              _this.fiber$playBgm(_thread);
              __pc=22;return;
            case 22:
              
            case 23    :
              
              __pc=92    ;break;
            case 24    :
              if (!(_this.allowY==7)) { __pc=27    ; break; }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=26    ; break; }
              _this.fiber$stopBgm(_thread);
              __pc=25;return;
            case 25:
              
            case 26    :
              
              __pc=91    ;break;
            case 27    :
              if (!(_this.allowY==8)) { __pc=30    ; break; }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=29    ; break; }
              _this.fiber$pauseBgm(_thread);
              __pc=28;return;
            case 28:
              
            case 29    :
              
              __pc=90    ;break;
            case 30    :
              if (!(_this.allowY==9)) { __pc=33    ; break; }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=32    ; break; }
              _this.fiber$resumeBgm(_thread);
              __pc=31;return;
            case 31:
              
            case 32    :
              
              __pc=89    ;break;
            case 33    :
              if (!(_this.allowY==10)) { __pc=36    ; break; }
              if (_this.keyL==1||_this.keyL>=15) {
                _this.volume-=1;
                if (_this.volume<0) {
                  _this.volume=0;
                }
                
              }
              if (_this.keyR==1||_this.keyR>=15) {
                _this.volume+=1;
                
              }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=35    ; break; }
              _this.fiber$setBgmVolume(_thread);
              __pc=34;return;
            case 34:
              
            case 35    :
              
              __pc=88    ;break;
            case 36    :
              if (!(_this.allowY==11)) { __pc=39    ; break; }
              if (_this.keyL==1||_this.keyL>=15) {
                _this.tempo-=0.015625;
                if (_this.tempo<0) {
                  _this.tempo=0;
                }
                
              }
              if (_this.keyR==1||_this.keyR>=15) {
                _this.tempo+=0.015625;
                
              }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=38    ; break; }
              _this.fiber$setBgmTempo(_thread);
              __pc=37;return;
            case 37:
              
            case 38    :
              
              __pc=87    ;break;
            case 39    :
              if (!(_this.allowY==12)) { __pc=42    ; break; }
              if (_this.keyL==1||_this.keyL>=15) {
                _this.pan-=1/16;
                if (_this.pan<- 1) {
                  _this.pan=- 1;
                }
                
              }
              if (_this.keyR==1||_this.keyR>=15) {
                _this.pan+=1/16;
                if (_this.pan>1) {
                  _this.pan=1;
                }
                
              }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=41    ; break; }
              _this.fiber$setBgmPan(_thread);
              __pc=40;return;
            case 40:
              
            case 41    :
              
              __pc=86    ;break;
            case 42    :
              if (!(_this.allowY==13)) { __pc=45    ; break; }
              if (_this.keyL==1||_this.keyL>=15) {
                _this.loop=! _this.loop;
                
              }
              if (_this.keyR==1||_this.keyR>=15) {
                _this.loop=! _this.loop;
                
              }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=44    ; break; }
              _this.fiber$setBgmLoop(_thread);
              __pc=43;return;
            case 43:
              
            case 44    :
              
              __pc=85    ;break;
            case 45    :
              if (!(_this.allowY==14)) { __pc=48    ; break; }
              if (_this.keyL==1||_this.keyL>=15) {
                _this.loopStartTime-=0.1;
                if (_this.loopStartTime<0) {
                  _this.loopStartTime=0;
                }
                
              }
              if (_this.keyR==1||_this.keyR>=15) {
                _this.loopStartTime+=0.1;
                
              }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=47    ; break; }
              _this.fiber$setBgmLoopStartTime(_thread);
              __pc=46;return;
            case 46:
              
            case 47    :
              
              __pc=84    ;break;
            case 48    :
              if (!(_this.allowY==15)) { __pc=51    ; break; }
              if (_this.keyL==1||_this.keyL>=15) {
                _this.loopEndTime-=0.1;
                if (_this.loopEndTime<0) {
                  _this.loopEndTime=0;
                }
                
              }
              if (_this.keyR==1||_this.keyR>=15) {
                _this.loopEndTime+=0.1;
                
              }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=50    ; break; }
              _this.fiber$setBgmLoopEndTime(_thread);
              __pc=49;return;
            case 49:
              
            case 50    :
              
              __pc=83    ;break;
            case 51    :
              if (!(_this.allowY==16)) { __pc=54    ; break; }
              if (_this.keyL==1||_this.keyL>=15) {
                _this.masterVolume-=1;
                if (_this.masterVolume<0) {
                  _this.masterVolume=0;
                }
                
              }
              if (_this.keyR==1||_this.keyR>=15) {
                _this.masterVolume+=1;
                
              }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=53    ; break; }
              _this.fiber$setMasterVolume(_thread);
              __pc=52;return;
            case 52:
              
            case 53    :
              
              __pc=82    ;break;
            case 54    :
              if (!(_this.allowY==17)) { __pc=57    ; break; }
              if (_this.keyL==1||_this.keyL>=15) {
                _this.bgmMasterVolume-=1;
                if (_this.bgmMasterVolume<0) {
                  _this.bgmMasterVolume=0;
                }
                
              }
              if (_this.keyR==1||_this.keyR>=15) {
                _this.bgmMasterVolume+=1;
                
              }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=56    ; break; }
              _this.fiber$setBgmMasterVolume(_thread);
              __pc=55;return;
            case 55:
              
            case 56    :
              
              __pc=81    ;break;
            case 57    :
              if (!(_this.allowY==18)) { __pc=60    ; break; }
              if (_this.keyL==1||_this.keyL>=15) {
                _this.seMasterVolume-=1;
                if (_this.seMasterVolume<0) {
                  _this.seMasterVolume=0;
                }
                
              }
              if (_this.keyR==1||_this.keyR>=15) {
                _this.seMasterVolume+=1;
                
              }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=59    ; break; }
              _this.fiber$setSeMasterVolume(_thread);
              __pc=58;return;
            case 58:
              
            case 59    :
              
              __pc=80    ;break;
            case 60    :
              if (!(_this.allowY==19)) { __pc=63    ; break; }
              if (_this.keyL==1||_this.keyL>=15) {
                _this.bgmsPlayNum-=1;
                if (_this.bgmsPlayNum<2) {
                  _this.bgmsPlayNum=2;
                }
                
              }
              if (_this.keyR==1||_this.keyR>=15) {
                _this.bgmsPlayNum+=1;
                _this.size = Tonyu.globals.$sound.getBGMPlayerMax();
                
                if (_this.bgmsPlayNum>_this.size) {
                  _this.bgmsPlayNum=_this.size;
                }
                
              }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=62    ; break; }
              _this.fiber$playBgms(_thread);
              __pc=61;return;
            case 61:
              
            case 62    :
              
              __pc=79    ;break;
            case 63    :
              if (!(_this.allowY==20)) { __pc=66    ; break; }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=65    ; break; }
              _this.fiber$allStopBgm(_thread);
              __pc=64;return;
            case 64:
              
            case 65    :
              
              __pc=78    ;break;
            case 66    :
              if (!(_this.allowY==21)) { __pc=69    ; break; }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=68    ; break; }
              _this.fiber$allResetBgm(_thread);
              __pc=67;return;
            case 67:
              
            case 68    :
              
              __pc=77    ;break;
            case 69    :
              if (!(_this.allowY==22)) { __pc=72    ; break; }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=71    ; break; }
              _this.fiber$playSe(_thread);
              __pc=70;return;
            case 70:
              
            case 71    :
              
              __pc=76    ;break;
            case 72    :
              if (!(_this.allowY==23)) { __pc=75    ; break; }
              if (!(_this.keyZ==1||_this.keyZ>=15)) { __pc=74    ; break; }
              _this.fiber$textHide(_thread);
              __pc=73;return;
            case 73:
              
            case 74    :
              
            case 75    :
              
            case 76    :
              
            case 77    :
              
            case 78    :
              
            case 79    :
              
            case 80    :
              
            case 81    :
              
            case 82    :
              
            case 83    :
              
            case 84    :
              
            case 85    :
              
            case 86    :
              
            case 87    :
              
            case 88    :
              
            case 89    :
              
            case 90    :
              
            case 91    :
              
            case 92    :
              
            case 93    :
              
            case 94    :
              
            case 95    :
              
            case 96    :
              
            case 97    :
              
            case 98    :
              
              if (!(_this.keyX==1)) { __pc=100   ; break; }
              _this.fiber$bgmPlayerMode(_thread);
              __pc=99;return;
            case 99:
              
            case 100   :
              
              if (_this.isTextShow) {
                _this.textBgmId.text="bgmID : "+(_this.bgmId==- 1?"default(0)":_this.bgmId);
                _this.textSelectBgm.text="selectBGM : ("+(_this.selectBgmIdx+1)+"/"+_this.sounds.length+") "+_this.sounds[_this.selectBgmIdx].name;
                _this.textLoopBgm.text="loop : "+_this.loop;
                _this.textStartTimeBgm.text="startTime : "+_this.startTime;
                _this.textLoopStartTimeBgm.text="loopStartTime : "+_this.loopStartTime;
                _this.textLoopEndTimeBgm.text="loopEndTime : "+_this.loopEndTime;
                _this.textVolumeBgm.text="volume : "+_this.volume;
                _this.textTempoBgm.text="tempo : "+_this.tempo;
                _this.textPanBgm.text="pan : "+_this.pan;
                _this.textMasterVolume.text="masterVolume : "+_this.masterVolume;
                _this.textBgmMasterVolume.text="bgmMasterVolume : "+_this.bgmMasterVolume;
                _this.textSeMasterVolume.text="seMasterVolume : "+_this.seMasterVolume;
                if (_this.bgmId==- 1) {
                  _this.textPlayingBgmName.text="bgmPlayingBGM : "+Tonyu.globals.$sound.getPlayingBGMName();
                  _this.textGetBgmCurrentTime.text="bgmCurrentTime : "+Tonyu.globals.$sound.getBGMCurrentTime();
                  _this.textGetBgmLength.text="bgmLength : "+Tonyu.globals.$sound.getBGMLength();
                  _this.textGetBgmVolume.text="bgmVolume : "+Tonyu.globals.$sound.getBGMVolume();
                  _this.textGetBgmTempo.text="bgmTempo : "+Tonyu.globals.$sound.getBGMTempo();
                  _this.textGetBgmPan.text="bgmPan : "+Tonyu.globals.$sound.getBGMPan();
                  _this.textGetBgmLoop.text="bgmLoop : "+Tonyu.globals.$sound.isBGMLoop();
                  _this.textGetBgmLoopStartTime.text="bgmLoopStartTime : "+Tonyu.globals.$sound.getBGMLoopStartTime();
                  _this.textGetBgmLoopEndTime.text="bgmLoopEndTime : "+Tonyu.globals.$sound.getBGMLoopEndTime();
                  
                } else {
                  _this.textPlayingBgmName.text="bgmPlayingBGM : "+Tonyu.globals.$sound.getPlayingBGMNameID(_this.bgmId);
                  _this.textGetBgmCurrentTime.text="bgmCurrentTime : "+Tonyu.globals.$sound.getBGMCurrentTimeID(_this.bgmId);
                  _this.textGetBgmLength.text="bgmLength : "+Tonyu.globals.$sound.getBGMLengthID(_this.bgmId);
                  _this.textGetBgmVolume.text="bgmVolume : "+Tonyu.globals.$sound.getBGMVolumeID(_this.bgmId);
                  _this.textGetBgmTempo.text="bgmTempo : "+Tonyu.globals.$sound.getBGMTempoID(_this.bgmId);
                  _this.textGetBgmPan.text="bgmPan : "+Tonyu.globals.$sound.getBGMPanID(_this.bgmId);
                  _this.textGetBgmLoop.text="bgmLoop : "+Tonyu.globals.$sound.isBGMLoopID(_this.bgmId);
                  _this.textGetBgmLoopStartTime.text="bgmLoopStartTime : "+Tonyu.globals.$sound.getBGMLoopStartTimeID(_this.bgmId);
                  _this.textGetBgmLoopEndTime.text="bgmLoopEndTime : "+Tonyu.globals.$sound.getBGMLoopEndTimeID(_this.bgmId);
                  
                }
                _this.textGetMasterVolume.text="masterVolume : "+Tonyu.globals.$sound.getMasterVolume();
                _this.textGetBgmMasterVolume.text="bgmMasterVolume : "+Tonyu.globals.$sound.getBGMMasterVolume();
                _this.textGetSeMasterVolume.text="seMasterVolume : "+Tonyu.globals.$sound.getSEMasterVolume();
                _this.textMenuPlayBgms.text="← bgms play ("+_this.bgmsPlayNum+") →";
                _this.textMenuTextHide.text="text hide";
                
              } else {
                _this.textMenuTextHide.text="text show";
                
              }
              _this.textFPS.text="FPS : "+Tonyu.globals.$Boot.getMeasuredFps();
              if (T2MediaLib.context) {
                _this.drawText(0,Tonyu.globals.$screenHeight-20,"currentTime:"+T2MediaLib.context.currentTime,"#FFF",12);
                
              }
              _this.fiber$update(_thread);
              __pc=101;return;
            case 101:
              
              _this.textMenuBgmId.fillStyle="#FFF";
              _this.textMenuSelectBgm.fillStyle="#FFF";
              _this.textMenuStartTime.fillStyle="#FFF";
              _this.textMenuLoop.fillStyle="#FFF";
              _this.textMenuLoopStartTime.fillStyle="#FFF";
              _this.textMenuLoopEndTime.fillStyle="#FFF";
              _this.textMenuPlayBgm.fillStyle="#FFF";
              _this.textMenuStopBgm.fillStyle="#FFF";
              _this.textMenuPauseBgm.fillStyle="#FFF";
              _this.textMenuResumeBgm.fillStyle="#FFF";
              _this.textMenuBgmVolume.fillStyle="#FFF";
              _this.textMenuBgmTempo.fillStyle="#FFF";
              _this.textMenuBgmPan.fillStyle="#FFF";
              _this.textMenuBgmLoop.fillStyle="#FFF";
              _this.textMenuBgmLoopStartTime.fillStyle="#FFF";
              _this.textMenuBgmLoopEndTime.fillStyle="#FFF";
              _this.textMenuMasterVolume.fillStyle="#FFF";
              _this.textMenuBgmMasterVolume.fillStyle="#FFF";
              _this.textMenuSeMasterVolume.fillStyle="#FFF";
              _this.textMenuPlayBgms.fillStyle="#FFF";
              _this.textMenuAllStopBgm.fillStyle="#FFF";
              _this.textMenuAllResetBgm.fillStyle="#FFF";
              _this.textMenuPlaySe.fillStyle="#FFF";
              _this.textMenuTextHide.fillStyle="#FFF";
              _this.textMenuPlayerMode.fillStyle="#FFF";
              __pc=3;break;
            case 102   :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      playBgm :function _trc_Main_playBgm() {
        "use strict";
        var _this=this;
        var bgm;
        
        bgm = _this.sounds[_this.selectBgmIdx].name;
        
        if (_this.bgmOld&&bgm!=_this.bgmOld) {
          if (_this.isRemoveDecodedSoundDeta) {
            Tonyu.globals.$sound.removeDecodedSoundData(_this.bgmOld);
          }
          
        }
        _this.bgmOld=bgm;
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.playBGM(bgm,_this.loop,_this.startTime,_this.loopStartTime,_this.loopEndTime);
          
        } else {
          Tonyu.globals.$sound.playBGMID(_this.bgmId,bgm,_this.loop,_this.startTime,_this.loopStartTime,_this.loopEndTime);
          
        }
        _this.textMenuPlayBgm.fillStyle="#0F0";
      },
      fiber$playBgm :function _trc_Main_f_playBgm(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var bgm;
        
        bgm = _this.sounds[_this.selectBgmIdx].name;
        
        if (_this.bgmOld&&bgm!=_this.bgmOld) {
          if (_this.isRemoveDecodedSoundDeta) {
            Tonyu.globals.$sound.removeDecodedSoundData(_this.bgmOld);
          }
          
        }
        _this.bgmOld=bgm;
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.playBGM(bgm,_this.loop,_this.startTime,_this.loopStartTime,_this.loopEndTime);
          
        } else {
          Tonyu.globals.$sound.playBGMID(_this.bgmId,bgm,_this.loop,_this.startTime,_this.loopStartTime,_this.loopEndTime);
          
        }
        _this.textMenuPlayBgm.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      stopBgm :function _trc_Main_stopBgm() {
        "use strict";
        var _this=this;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.stopBGM();
          
        } else {
          Tonyu.globals.$sound.stopBGMID(_this.bgmId);
          
        }
        _this.textMenuStopBgm.fillStyle="#0F0";
      },
      fiber$stopBgm :function _trc_Main_f_stopBgm(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.stopBGM();
          
        } else {
          Tonyu.globals.$sound.stopBGMID(_this.bgmId);
          
        }
        _this.textMenuStopBgm.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      pauseBgm :function _trc_Main_pauseBgm() {
        "use strict";
        var _this=this;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.pauseBGM();
          
        } else {
          Tonyu.globals.$sound.pauseBGMID(_this.bgmId);
          
        }
        _this.textMenuPauseBgm.fillStyle="#0F0";
      },
      fiber$pauseBgm :function _trc_Main_f_pauseBgm(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.pauseBGM();
          
        } else {
          Tonyu.globals.$sound.pauseBGMID(_this.bgmId);
          
        }
        _this.textMenuPauseBgm.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      resumeBgm :function _trc_Main_resumeBgm() {
        "use strict";
        var _this=this;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.resumeBGM();
          
        } else {
          Tonyu.globals.$sound.resumeBGMID(_this.bgmId);
          
        }
        _this.textMenuResumeBgm.fillStyle="#0F0";
      },
      fiber$resumeBgm :function _trc_Main_f_resumeBgm(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.resumeBGM();
          
        } else {
          Tonyu.globals.$sound.resumeBGMID(_this.bgmId);
          
        }
        _this.textMenuResumeBgm.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      setBgmVolume :function _trc_Main_setBgmVolume() {
        "use strict";
        var _this=this;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.setBGMVolume(_this.volume);
          
        } else {
          Tonyu.globals.$sound.setBGMVolumeID(_this.bgmId,_this.volume);
          
        }
        _this.textMenuBgmVolume.fillStyle="#0F0";
      },
      fiber$setBgmVolume :function _trc_Main_f_setBgmVolume(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.setBGMVolume(_this.volume);
          
        } else {
          Tonyu.globals.$sound.setBGMVolumeID(_this.bgmId,_this.volume);
          
        }
        _this.textMenuBgmVolume.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      setBgmTempo :function _trc_Main_setBgmTempo() {
        "use strict";
        var _this=this;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.setBGMTempo(_this.tempo);
          
        } else {
          Tonyu.globals.$sound.setBGMTempoID(_this.bgmId,_this.tempo);
          
        }
        _this.textMenuBgmTempo.fillStyle="#0F0";
      },
      fiber$setBgmTempo :function _trc_Main_f_setBgmTempo(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.setBGMTempo(_this.tempo);
          
        } else {
          Tonyu.globals.$sound.setBGMTempoID(_this.bgmId,_this.tempo);
          
        }
        _this.textMenuBgmTempo.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      setBgmPan :function _trc_Main_setBgmPan() {
        "use strict";
        var _this=this;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.setBGMPan(_this.pan);
          
        } else {
          Tonyu.globals.$sound.setBGMPanID(_this.bgmId,_this.pan);
          
        }
        _this.textMenuBgmPan.fillStyle="#0F0";
      },
      fiber$setBgmPan :function _trc_Main_f_setBgmPan(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.setBGMPan(_this.pan);
          
        } else {
          Tonyu.globals.$sound.setBGMPanID(_this.bgmId,_this.pan);
          
        }
        _this.textMenuBgmPan.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      setBgmLoop :function _trc_Main_setBgmLoop() {
        "use strict";
        var _this=this;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.setBGMLoop(_this.loop);
          
        } else {
          Tonyu.globals.$sound.setBGMLoopID(_this.bgmId,_this.loop);
          
        }
        _this.textMenuBgmLoop.fillStyle="#0F0";
      },
      fiber$setBgmLoop :function _trc_Main_f_setBgmLoop(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.setBGMLoop(_this.loop);
          
        } else {
          Tonyu.globals.$sound.setBGMLoopID(_this.bgmId,_this.loop);
          
        }
        _this.textMenuBgmLoop.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      setBgmLoopStartTime :function _trc_Main_setBgmLoopStartTime() {
        "use strict";
        var _this=this;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.setBGMLoopStartTime(_this.loopStartTime);
          
        } else {
          Tonyu.globals.$sound.setBGMLoopStartTimeID(_this.bgmId,_this.loopStartTime);
          
        }
        _this.textMenuBgmLoopStartTime.fillStyle="#0F0";
      },
      fiber$setBgmLoopStartTime :function _trc_Main_f_setBgmLoopStartTime(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.setBGMLoopStartTime(_this.loopStartTime);
          
        } else {
          Tonyu.globals.$sound.setBGMLoopStartTimeID(_this.bgmId,_this.loopStartTime);
          
        }
        _this.textMenuBgmLoopStartTime.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      setBgmLoopEndTime :function _trc_Main_setBgmLoopEndTime() {
        "use strict";
        var _this=this;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.setBGMLoopEndTime(_this.loopEndTime);
          
        } else {
          Tonyu.globals.$sound.setBGMLoopEndTimeID(_this.bgmId,_this.loopEndTime);
          
        }
        _this.textMenuBgmLoopEndTime.fillStyle="#0F0";
      },
      fiber$setBgmLoopEndTime :function _trc_Main_f_setBgmLoopEndTime(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.bgmId==- 1) {
          Tonyu.globals.$sound.setBGMLoopEndTime(_this.loopEndTime);
          
        } else {
          Tonyu.globals.$sound.setBGMLoopEndTimeID(_this.bgmId,_this.loopEndTime);
          
        }
        _this.textMenuBgmLoopEndTime.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      setMasterVolume :function _trc_Main_setMasterVolume() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$sound.setMasterVolume(_this.masterVolume);
        _this.textMenuMasterVolume.fillStyle="#0F0";
      },
      fiber$setMasterVolume :function _trc_Main_f_setMasterVolume(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$sound.setMasterVolume(_this.masterVolume);
        _this.textMenuMasterVolume.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      setBgmMasterVolume :function _trc_Main_setBgmMasterVolume() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$sound.setBGMMasterVolume(_this.bgmMasterVolume);
        _this.textMenuBgmMasterVolume.fillStyle="#0F0";
      },
      fiber$setBgmMasterVolume :function _trc_Main_f_setBgmMasterVolume(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$sound.setBGMMasterVolume(_this.bgmMasterVolume);
        _this.textMenuBgmMasterVolume.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      setSeMasterVolume :function _trc_Main_setSeMasterVolume() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$sound.setSEMasterVolume(_this.seMasterVolume);
        _this.textMenuSeMasterVolume.fillStyle="#0F0";
      },
      fiber$setSeMasterVolume :function _trc_Main_f_setSeMasterVolume(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$sound.setSEMasterVolume(_this.seMasterVolume);
        _this.textMenuSeMasterVolume.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      playBgms :function _trc_Main_playBgms() {
        "use strict";
        var _this=this;
        var bgm;
        var i;
        
        bgm = _this.sounds[_this.selectBgmIdx].name;
        
        i = 0;
        for (; i<_this.bgmsPlayNum ; i++) {
          {
            Tonyu.globals.$sound.playBGMID(i,bgm,_this.loop,_this.startTime,_this.loopStartTime,_this.loopEndTime);
          }
        }
        _this.textMenuPlayBgms.fillStyle="#0F0";
      },
      fiber$playBgms :function _trc_Main_f_playBgms(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var bgm;
        var i;
        
        bgm = _this.sounds[_this.selectBgmIdx].name;
        
        i = 0;
        for (; i<_this.bgmsPlayNum ; i++) {
          {
            Tonyu.globals.$sound.playBGMID(i,bgm,_this.loop,_this.startTime,_this.loopStartTime,_this.loopEndTime);
          }
        }
        _this.textMenuPlayBgms.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      allStopBgm :function _trc_Main_allStopBgm() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$sound.allStopBGM();
        _this.textMenuAllStopBgm.fillStyle="#0F0";
      },
      fiber$allStopBgm :function _trc_Main_f_allStopBgm(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$sound.allStopBGM();
        _this.textMenuAllStopBgm.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      allResetBgm :function _trc_Main_allResetBgm() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$sound.allResetBGM();
        _this.textMenuAllResetBgm.fillStyle="#0F0";
      },
      fiber$allResetBgm :function _trc_Main_f_allResetBgm(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$sound.allResetBGM();
        _this.textMenuAllResetBgm.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      playSe :function _trc_Main_playSe() {
        "use strict";
        var _this=this;
        var bgm;
        
        bgm = _this.sounds[_this.selectBgmIdx].name;
        
        Tonyu.globals.$sound.playSE(bgm,_this.volume,_this.pan,_this.tempo,_this.startTime);
        _this.textMenuPlaySe.fillStyle="#0F0";
      },
      fiber$playSe :function _trc_Main_f_playSe(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var bgm;
        
        bgm = _this.sounds[_this.selectBgmIdx].name;
        
        Tonyu.globals.$sound.playSE(bgm,_this.volume,_this.pan,_this.tempo,_this.startTime);
        _this.textMenuPlaySe.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      textHide :function _trc_Main_textHide() {
        "use strict";
        var _this=this;
        
        _this.isTextShow=! _this.isTextShow;
        if (_this.isTextShow) {
          _this.textMenuBgmId.show();
          _this.textMenuSelectBgm.show();
          _this.textMenuLoop.show();
          _this.textMenuStartTime.show();
          _this.textMenuLoopStartTime.show();
          _this.textMenuLoopEndTime.show();
          _this.textMenuPlayBgm.show();
          _this.textMenuStopBgm.show();
          _this.textMenuPauseBgm.show();
          _this.textMenuResumeBgm.show();
          _this.textMenuBgmVolume.show();
          _this.textMenuBgmTempo.show();
          _this.textMenuBgmPan.show();
          _this.textMenuBgmLoop.show();
          _this.textMenuBgmLoopStartTime.show();
          _this.textMenuBgmLoopEndTime.show();
          _this.textMenuMasterVolume.show();
          _this.textMenuBgmMasterVolume.show();
          _this.textMenuSeMasterVolume.show();
          _this.textMenuPlayBgms.show();
          _this.textMenuAllStopBgm.show();
          _this.textMenuAllResetBgm.show();
          _this.textMenuPlaySe.show();
          _this.textBgmId.show();
          _this.textSelectBgm.show();
          _this.textLoopBgm.show();
          _this.textStartTimeBgm.show();
          _this.textLoopStartTimeBgm.show();
          _this.textLoopEndTimeBgm.show();
          _this.textVolumeBgm.show();
          _this.textTempoBgm.show();
          _this.textPanBgm.show();
          _this.textMasterVolume.show();
          _this.textBgmMasterVolume.show();
          _this.textSeMasterVolume.show();
          _this.textPlayingBgmName.show();
          _this.textGetBgmCurrentTime.show();
          _this.textGetBgmLength.show();
          _this.textGetBgmVolume.show();
          _this.textGetBgmTempo.show();
          _this.textGetBgmPan.show();
          _this.textGetBgmLoop.show();
          _this.textGetBgmLoopStartTime.show();
          _this.textGetBgmLoopEndTime.show();
          _this.textGetMasterVolume.show();
          _this.textGetBgmMasterVolume.show();
          _this.textGetSeMasterVolume.show();
          
        } else {
          _this.textMenuBgmId.hide();
          _this.textMenuSelectBgm.hide();
          _this.textMenuLoop.hide();
          _this.textMenuStartTime.hide();
          _this.textMenuLoopStartTime.hide();
          _this.textMenuLoopEndTime.hide();
          _this.textMenuPlayBgm.hide();
          _this.textMenuStopBgm.hide();
          _this.textMenuPauseBgm.hide();
          _this.textMenuResumeBgm.hide();
          _this.textMenuBgmVolume.hide();
          _this.textMenuBgmTempo.hide();
          _this.textMenuBgmPan.hide();
          _this.textMenuBgmLoop.hide();
          _this.textMenuBgmLoopStartTime.hide();
          _this.textMenuBgmLoopEndTime.hide();
          _this.textMenuMasterVolume.hide();
          _this.textMenuBgmMasterVolume.hide();
          _this.textMenuSeMasterVolume.hide();
          _this.textMenuPlayBgms.hide();
          _this.textMenuAllStopBgm.hide();
          _this.textMenuAllResetBgm.hide();
          _this.textMenuPlaySe.hide();
          _this.textBgmId.hide();
          _this.textSelectBgm.hide();
          _this.textLoopBgm.hide();
          _this.textStartTimeBgm.hide();
          _this.textLoopStartTimeBgm.hide();
          _this.textLoopEndTimeBgm.hide();
          _this.textVolumeBgm.hide();
          _this.textTempoBgm.hide();
          _this.textPanBgm.hide();
          _this.textMasterVolume.hide();
          _this.textBgmMasterVolume.hide();
          _this.textSeMasterVolume.hide();
          _this.textPlayingBgmName.hide();
          _this.textGetBgmCurrentTime.hide();
          _this.textGetBgmLength.hide();
          _this.textGetBgmVolume.hide();
          _this.textGetBgmTempo.hide();
          _this.textGetBgmPan.hide();
          _this.textGetBgmLoop.hide();
          _this.textGetBgmLoopStartTime.hide();
          _this.textGetBgmLoopEndTime.hide();
          _this.textGetMasterVolume.hide();
          _this.textGetBgmMasterVolume.hide();
          _this.textGetSeMasterVolume.hide();
          _this.textMenuPlayBgms.hide();
          
        }
        _this.textMenuTextHide.fillStyle="#0F0";
      },
      fiber$textHide :function _trc_Main_f_textHide(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.isTextShow=! _this.isTextShow;
        if (_this.isTextShow) {
          _this.textMenuBgmId.show();
          _this.textMenuSelectBgm.show();
          _this.textMenuLoop.show();
          _this.textMenuStartTime.show();
          _this.textMenuLoopStartTime.show();
          _this.textMenuLoopEndTime.show();
          _this.textMenuPlayBgm.show();
          _this.textMenuStopBgm.show();
          _this.textMenuPauseBgm.show();
          _this.textMenuResumeBgm.show();
          _this.textMenuBgmVolume.show();
          _this.textMenuBgmTempo.show();
          _this.textMenuBgmPan.show();
          _this.textMenuBgmLoop.show();
          _this.textMenuBgmLoopStartTime.show();
          _this.textMenuBgmLoopEndTime.show();
          _this.textMenuMasterVolume.show();
          _this.textMenuBgmMasterVolume.show();
          _this.textMenuSeMasterVolume.show();
          _this.textMenuPlayBgms.show();
          _this.textMenuAllStopBgm.show();
          _this.textMenuAllResetBgm.show();
          _this.textMenuPlaySe.show();
          _this.textBgmId.show();
          _this.textSelectBgm.show();
          _this.textLoopBgm.show();
          _this.textStartTimeBgm.show();
          _this.textLoopStartTimeBgm.show();
          _this.textLoopEndTimeBgm.show();
          _this.textVolumeBgm.show();
          _this.textTempoBgm.show();
          _this.textPanBgm.show();
          _this.textMasterVolume.show();
          _this.textBgmMasterVolume.show();
          _this.textSeMasterVolume.show();
          _this.textPlayingBgmName.show();
          _this.textGetBgmCurrentTime.show();
          _this.textGetBgmLength.show();
          _this.textGetBgmVolume.show();
          _this.textGetBgmTempo.show();
          _this.textGetBgmPan.show();
          _this.textGetBgmLoop.show();
          _this.textGetBgmLoopStartTime.show();
          _this.textGetBgmLoopEndTime.show();
          _this.textGetMasterVolume.show();
          _this.textGetBgmMasterVolume.show();
          _this.textGetSeMasterVolume.show();
          
        } else {
          _this.textMenuBgmId.hide();
          _this.textMenuSelectBgm.hide();
          _this.textMenuLoop.hide();
          _this.textMenuStartTime.hide();
          _this.textMenuLoopStartTime.hide();
          _this.textMenuLoopEndTime.hide();
          _this.textMenuPlayBgm.hide();
          _this.textMenuStopBgm.hide();
          _this.textMenuPauseBgm.hide();
          _this.textMenuResumeBgm.hide();
          _this.textMenuBgmVolume.hide();
          _this.textMenuBgmTempo.hide();
          _this.textMenuBgmPan.hide();
          _this.textMenuBgmLoop.hide();
          _this.textMenuBgmLoopStartTime.hide();
          _this.textMenuBgmLoopEndTime.hide();
          _this.textMenuMasterVolume.hide();
          _this.textMenuBgmMasterVolume.hide();
          _this.textMenuSeMasterVolume.hide();
          _this.textMenuPlayBgms.hide();
          _this.textMenuAllStopBgm.hide();
          _this.textMenuAllResetBgm.hide();
          _this.textMenuPlaySe.hide();
          _this.textBgmId.hide();
          _this.textSelectBgm.hide();
          _this.textLoopBgm.hide();
          _this.textStartTimeBgm.hide();
          _this.textLoopStartTimeBgm.hide();
          _this.textLoopEndTimeBgm.hide();
          _this.textVolumeBgm.hide();
          _this.textTempoBgm.hide();
          _this.textPanBgm.hide();
          _this.textMasterVolume.hide();
          _this.textBgmMasterVolume.hide();
          _this.textSeMasterVolume.hide();
          _this.textPlayingBgmName.hide();
          _this.textGetBgmCurrentTime.hide();
          _this.textGetBgmLength.hide();
          _this.textGetBgmVolume.hide();
          _this.textGetBgmTempo.hide();
          _this.textGetBgmPan.hide();
          _this.textGetBgmLoop.hide();
          _this.textGetBgmLoopStartTime.hide();
          _this.textGetBgmLoopEndTime.hide();
          _this.textGetMasterVolume.hide();
          _this.textGetBgmMasterVolume.hide();
          _this.textGetSeMasterVolume.hide();
          _this.textMenuPlayBgms.hide();
          
        }
        _this.textMenuTextHide.fillStyle="#0F0";
        
        _thread.retVal=_this;return;
      },
      bgmPlayerMode :function _trc_Main_bgmPlayerMode() {
        "use strict";
        var _this=this;
        
        _this.loadPage(Tonyu.classes.user.BGMPlayer);
        _this.textMenuPlayerMode.fillStyle="#0F0";
      },
      fiber$bgmPlayerMode :function _trc_Main_f_bgmPlayerMode(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_Main_ent_bgmPlayerMode(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$loadPage(_thread, Tonyu.classes.user.BGMPlayer);
              __pc=1;return;
            case 1:
              
              _this.textMenuPlayerMode.fillStyle="#0F0";
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"playBgm":{"nowait":false},"stopBgm":{"nowait":false},"pauseBgm":{"nowait":false},"resumeBgm":{"nowait":false},"setBgmVolume":{"nowait":false},"setBgmTempo":{"nowait":false},"setBgmPan":{"nowait":false},"setBgmLoop":{"nowait":false},"setBgmLoopStartTime":{"nowait":false},"setBgmLoopEndTime":{"nowait":false},"setMasterVolume":{"nowait":false},"setBgmMasterVolume":{"nowait":false},"setSeMasterVolume":{"nowait":false},"playBgms":{"nowait":false},"allStopBgm":{"nowait":false},"allResetBgm":{"nowait":false},"playSe":{"nowait":false},"textHide":{"nowait":false},"bgmPlayerMode":{"nowait":false}},"fields":{"size":{},"isRemoveDecodedSoundDeta":{},"sounds":{},"allowY":{},"pad":{},"bgmOld":{},"bgmId":{},"selectBgmIdx":{},"loop":{},"startTime":{},"loopStartTime":{},"loopEndTime":{},"volume":{},"tempo":{},"pan":{},"masterVolume":{},"bgmMasterVolume":{},"seMasterVolume":{},"bgmsPlayNum":{},"isTextShow":{},"isBgmPlayerMode":{},"tempX":{},"tempY":{},"TEMP_Y_ADD":{},"TEMP_TEXT_SIZE":{},"textMenuBgmId":{},"textMenuSelectBgm":{},"textMenuLoop":{},"textMenuStartTime":{},"textMenuLoopStartTime":{},"textMenuLoopEndTime":{},"textMenuPlayBgm":{},"textMenuStopBgm":{},"textMenuPauseBgm":{},"textMenuResumeBgm":{},"textMenuBgmVolume":{},"textMenuBgmTempo":{},"textMenuBgmPan":{},"textMenuBgmLoop":{},"textMenuBgmLoopStartTime":{},"textMenuBgmLoopEndTime":{},"textMenuMasterVolume":{},"textMenuBgmMasterVolume":{},"textMenuSeMasterVolume":{},"textMenuPlayBgms":{},"textMenuAllStopBgm":{},"textMenuAllResetBgm":{},"textMenuPlaySe":{},"textMenuTextHide":{},"textMenuPlayerMode":{},"textBgmId":{},"textSelectBgm":{},"textLoopBgm":{},"textStartTimeBgm":{},"textLoopStartTimeBgm":{},"textLoopEndTimeBgm":{},"textVolumeBgm":{},"textTempoBgm":{},"textPanBgm":{},"textMasterVolume":{},"textBgmMasterVolume":{},"textSeMasterVolume":{},"textPlayingBgmName":{},"textGetBgmCurrentTime":{},"textGetBgmLength":{},"textGetBgmVolume":{},"textGetBgmTempo":{},"textGetBgmPan":{},"textGetBgmLoop":{},"textGetBgmLoopStartTime":{},"textGetBgmLoopEndTime":{},"textGetMasterVolume":{},"textGetBgmMasterVolume":{},"textGetSeMasterVolume":{},"textFPS":{},"keyL":{},"keyR":{},"keyU":{},"keyD":{},"keyZ":{},"keyX":{}}}
});
Tonyu.klass.define({
  fullName: 'user.TestChar',
  shortName: 'TestChar',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_TestChar_main() {
        "use strict";
        var _this=this;
        
        while (true) {
          _this.x+=3;
          if (_this.x>Tonyu.globals.$screenWidth+16) {
            _this.x-=Tonyu.globals.$screenWidth+32;
          }
          _this.update();
          
        }
      },
      fiber$main :function _trc_TestChar_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_TestChar_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              _this.x+=3;
              if (_this.x>Tonyu.globals.$screenWidth+16) {
                _this.x-=Tonyu.globals.$screenWidth+32;
              }
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{}}
});

//# sourceMappingURL=concat.js.map